home *** CD-ROM | disk | FTP | other *** search
/ PC World Komputer 2010 April / PCWorld0410.iso / hity wydania / Ubuntu 9.10 PL / karmelkowy-koliberek-desktop-9.10-i386-PL.iso / casper / initrd.lz / initrd / scripts / local-top / cryptroot < prev    next >
Encoding:
Text File  |  2009-10-28  |  6.9 KB  |  344 lines

  1. #!/bin/sh
  2.  
  3. # source for log_*_msg() functions, see LP: #272301
  4. . /scripts/functions
  5.  
  6. #
  7. # Standard initramfs preamble
  8. #
  9. prereqs()
  10. {
  11.     # Make sure that cryptroot is run last in local-top
  12.     for req in /scripts/local-top/*; do
  13.         script=${req##*/}
  14.         if [ $script != cryptroot ]; then
  15.             echo $script
  16.         fi
  17.     done
  18. }
  19.  
  20. case $1 in
  21. prereqs)
  22.     prereqs
  23.     exit 0
  24.     ;;
  25. esac
  26.  
  27.  
  28. #
  29. # Helper functions
  30. #
  31. message()
  32. {
  33.     if [ -p /dev/.initramfs/usplash_outfifo ] && [ -x /sbin/usplash_write ]; then
  34.         usplash_write "TEXT-URGENT $@"
  35.     else
  36.         echo "$@" >&2
  37.     fi
  38.     return 0
  39. }
  40.  
  41. udev_settle()
  42. {
  43.     # Wait for udev to be ready, see https://launchpad.net/bugs/85640
  44.     if [ -x /sbin/udevadm ]; then
  45.         /sbin/udevadm settle --timeout=30
  46.     elif [ -x /sbin/udevsettle ]; then
  47.         /sbin/udevsettle --timeout=30
  48.     fi
  49.     return 0
  50. }
  51.  
  52. parse_options()
  53. {
  54.     local cryptopts
  55.     cryptopts="$1"
  56.  
  57.     if [ -z "$cryptopts" ]; then
  58.         return 1
  59.     fi
  60.  
  61.     # Defaults
  62.     cryptcipher=aes-cbc-essiv:sha256
  63.     cryptsize=256
  64.     crypthash=ripemd160
  65.     crypttarget=cryptroot
  66.     cryptsource=""
  67.     cryptlvm=""
  68.     cryptkeyscript=""
  69.     cryptkey="" # This is only used as an argument to an eventual keyscript
  70.     crypttries=3
  71.  
  72.     local IFS=" ,"
  73.     for x in $cryptopts; do
  74.         case $x in
  75.         hash=*)
  76.             crypthash=${x#hash=}
  77.             ;;
  78.         size=*)
  79.             cryptsize=${x#size=}
  80.             ;;
  81.         cipher=*)
  82.             cryptcipher=${x#cipher=}
  83.             ;;
  84.         target=*)
  85.             crypttarget=${x#target=}
  86.             ;;
  87.         source=*)
  88.             cryptsource=${x#source=}
  89.             if [ ${cryptsource#UUID=} != $cryptsource ]; then
  90.                 cryptsource="/dev/disk/by-uuid/${cryptsource#UUID=}"
  91.             elif [ ${cryptsource#LABEL=} != $cryptsource ]; then
  92.                 cryptsource="/dev/disk/by-label/${cryptsource#LABEL=}"
  93.             fi
  94.             ;;
  95.         lvm=*)
  96.             cryptlvm=${x#lvm=}
  97.             ;;
  98.         keyscript=*)
  99.             cryptkeyscript=${x#keyscript=}
  100.             ;;
  101.         key=*)
  102.             if [ "${x#key=}" != "none" ]; then
  103.                 cryptkey=${x#key=}
  104.             fi
  105.             ;;
  106.         tries=*)
  107.             crypttries="${x#tries=}"
  108.             case "$crypttries" in
  109.               *[![:digit:].]*)
  110.                 crypttries=3
  111.                 ;;
  112.             esac
  113.             ;;
  114.         esac
  115.     done
  116.  
  117.     if [ -z "$cryptsource" ]; then
  118.         message "cryptsetup: source parameter missing"
  119.         return 1
  120.     fi
  121.     return 0
  122. }
  123.  
  124. activate_vg()
  125. {
  126.     local vg
  127.     vg="${1#/dev/mapper/}"
  128.  
  129.     # Sanity checks
  130.     if [ ! -x /sbin/lvm ] || [ "$vg" = "$1" ]; then
  131.         return 1
  132.     fi
  133.  
  134.     # Make sure that the device contains at least one dash
  135.     if [ "${vg%%-*}" = "$vg" ]; then
  136.         return 1
  137.     fi
  138.  
  139.     # Split volume group from logical volume.
  140.     vg=$(echo ${vg} | sed -e 's#\(.*\)\([^-]\)-[^-].*#\1\2#')
  141.  
  142.     # Reduce padded --'s to -'s
  143.     vg=$(echo ${vg} | sed -e 's#--#-#g')
  144.  
  145.     lvm vgchange -ay ${vg}
  146.     return $?
  147. }
  148.  
  149. activate_evms()
  150. {
  151.     local dev module
  152.     dev="${1#/dev/evms/}"
  153.  
  154.     # Sanity checks
  155.     if [ ! -x /sbin/evms_activate ] || [ "$dev" = "$1" ]; then
  156.         return 1
  157.     fi
  158.  
  159.     # Load modules used by evms
  160.     for module in dm-mod linear raid0 raid1 raid10 raid5 raid6; do
  161.         modprobe -q $module
  162.     done
  163.  
  164.     # Activate it
  165.     /sbin/evms_activate
  166.     return $?
  167. }
  168.  
  169. setup_mapping()
  170. {
  171.     local opts count cryptcreate cryptremove NEWROOT
  172.     opts="$1"
  173.  
  174.     if [ -z "$opts" ]; then
  175.         return 0
  176.     fi
  177.  
  178.     parse_options "$opts" || return 1
  179.  
  180.     if [ -n "$cryptkeyscript" ] && [ ! -x "$cryptkeyscript" ]; then
  181.         message "cryptsetup: error - script \"$cryptkeyscript\" missing"
  182.         return 1
  183.     fi
  184.  
  185.     # The same target can be specified multiple times
  186.     # e.g. root and resume lvs-on-lvm-on-crypto
  187.     if [ -e "/dev/mapper/$crypttarget" ]; then
  188.         return 0
  189.     fi
  190.  
  191.     modprobe -q dm_crypt
  192.  
  193.     # Make sure the cryptsource device is available
  194.     if [ ! -e $cryptsource ]; then
  195.         activate_vg $cryptsource
  196.         activate_evms $cryptsource
  197.     fi
  198.  
  199.     # If the encrypted source device hasn't shown up yet, give it a
  200.     # little while to deal with removable devices
  201.  
  202.     # the following lines below have been taken from
  203.     # /usr/share/initramfs-tools/scripts/local, as suggested per
  204.     # https://launchpad.net/bugs/164044
  205.     if [ ! -e "$cryptsource" ]
  206.     then
  207.         log_begin_msg "Waiting for encrypted source device..."
  208.  
  209.         # Default delay is 180s
  210.         if [ -z "${ROOTDELAY}" ]; then
  211.             slumber=180
  212.         else
  213.             slumber=${ROOTDELAY}
  214.         fi
  215.         if [ -x /sbin/usplash_write ]; then
  216.             /sbin/usplash_write "TIMEOUT ${slumber}" || true
  217.         fi
  218.  
  219.         slumber=$(( ${slumber} * 10 ))
  220.         while [ ! -e "$cryptsource" ]
  221.         do
  222.             /bin/sleep 0.1
  223.             slumber=$(( ${slumber} - 1 ))
  224.             [ ${slumber} -gt 0 ] || break
  225.         done
  226.  
  227.         if [ ${slumber} -gt 0 ]; then
  228.             log_end_msg 0
  229.         else
  230.             log_end_msg 1 || true
  231.         fi
  232.         if [ -x /sbin/usplash_write ]; then
  233.             /sbin/usplash_write "TIMEOUT 15" || true
  234.         fi
  235.     fi
  236.     udev_settle
  237.  
  238.     # We've given up, but we'll let the user fix matters if they can
  239.     while [ ! -e "${cryptsource}" ]; do
  240.         echo "    Check cryptopts=source= bootarg cat /proc/cmdline"
  241.         echo "    or missing modules, devices: cat /proc/modules ls /dev"
  242.         panic -r "ALERT!  ${cryptsource} does not exist.  Dropping to a shell!"
  243.     done
  244.  
  245.     # Prepare commands
  246.     if /sbin/cryptsetup isLuks $cryptsource > /dev/null 2>&1; then
  247.         cryptcreate="/sbin/cryptsetup -T 1 luksOpen $cryptsource $crypttarget"
  248.     else
  249.         cryptcreate="/sbin/cryptsetup -T 1 -c $cryptcipher -s $cryptsize -h $crypthash create $crypttarget $cryptsource"
  250.     fi
  251.     cryptremove="/sbin/cryptsetup remove $crypttarget"
  252.     NEWROOT="/dev/mapper/$crypttarget"
  253.  
  254.     # Try to get a satisfactory password $crypttries times
  255.     count=0
  256.     while [ $crypttries -le 0 ] || [ $count -lt $crypttries ]; do
  257.         count=$(( $count + 1 ))
  258.  
  259.         if [ $count -gt 1 ]; then
  260.             sleep 3
  261.         fi
  262.  
  263.         if [ $crypttries -gt 0 ] && [ $count -gt $crypttries ]; then
  264.             message "cryptsetup: maximum number of tries exceeded for $crypttarget"
  265.             return 1
  266.         fi
  267.  
  268.         if [ -z "$cryptkeyscript" ]; then
  269.             cryptkeyscript="/lib/cryptsetup/askpass"
  270.             cryptkey="Unlocking the disk $cryptsource ($crypttarget)\nEnter passphrase: "
  271.         fi
  272.  
  273.  
  274.         if ! crypttarget="$crypttarget" cryptsource="$cryptsource" \
  275.              $cryptkeyscript "$cryptkey" | $cryptcreate --key-file=- ; then
  276.             message "cryptsetup: cryptsetup failed, bad password or options?"
  277.             continue
  278.         fi
  279.  
  280.         if [ ! -e "$NEWROOT" ]; then
  281.             message "cryptsetup: unknown error setting up device mapping"
  282.             return 1
  283.         fi
  284.  
  285.         FSTYPE=''
  286.         eval $(fstype < "$NEWROOT")
  287.  
  288.         # See if we need to setup lvm on the crypto device
  289.         if [ "$FSTYPE" = "lvm" ] || [ "$FSTYPE" = "lvm2" ]; then
  290.             if [ -z "$cryptlvm" ]; then
  291.                 message "cryptsetup: lvm fs found but no lvm configured"
  292.                 return 1
  293.             elif ! activate_vg "/dev/mapper/$cryptlvm"; then
  294.                 # disable error message, LP: #151532
  295.                 #message "cryptsetup: failed to setup lvm device"
  296.                 return 1
  297.             fi
  298.  
  299.             NEWROOT="/dev/mapper/$cryptlvm"
  300.             eval $(fstype < "$NEWROOT")
  301.         fi
  302.  
  303.         if [ -z "$FSTYPE" ] || [ "$FSTYPE" = "unknown" ]; then
  304.             message "cryptsetup: unknown fstype, bad password or options?"
  305.             $cryptremove
  306.             continue
  307.         fi
  308.  
  309.         message "cryptsetup: $crypttarget setup successfully"
  310.         break
  311.     done
  312.  
  313.     udev_settle
  314.     return 0
  315. }
  316.  
  317. #
  318. # Begin real processing
  319. #
  320.  
  321. # Do we have any kernel boot arguments?
  322. found=''
  323. for opt in $(cat /proc/cmdline); do
  324.     case $opt in
  325.     cryptopts=*)
  326.         found=yes
  327.         setup_mapping "${opt#cryptopts=}"
  328.         ;;
  329.     esac
  330. done
  331.  
  332. if [ -n "$found" ]; then
  333.     exit 0
  334. fi
  335.  
  336. # Do we have any settings from the /conf/conf.d/cryptroot file?
  337. if [ -r /conf/conf.d/cryptroot ]; then
  338.     while read mapping <&3; do
  339.         setup_mapping "$mapping"
  340.     done 3< /conf/conf.d/cryptroot
  341. fi
  342.  
  343. exit 0
  344.